
#ifndef HOST_WAN_STATS_H
#define HOST_WAN_STATS_H


#define HOST_WAN_STATS_IP_NODE_INIT 1
#define HOST_WAN_STATS_IP_NODE_NOMATCH HOST_WAN_STATS_IP_NODE_INIT
#define HOST_WAN_STATS_IP_NODE_EXPIRED 0

struct host_ip_addr {
	unsigned char family;
	union {
		struct in_addr ipv4_sin_addr;
		struct in6_addr ipv6_sin_addr;
	};
};

struct device_address_list {
	struct hlist_node hlist;
	struct host_ip_addr addr;
	};

struct host_nf_tc {
	struct hlist_node hlist;
	unsigned int id;
	unsigned long long start_timestamp;
	unsigned long long rx_bytes;
        unsigned long long tx_bytes;
	unsigned long long rx_packets;
	unsigned long long tx_packets;
	int in_use;
};
struct host_nf_tc_ip_list {
	struct hlist_node hlist;
	int ct_running_count;
	unsigned long long rx_bytes;
        unsigned long long tx_bytes;
	unsigned long long rx_packets;
	unsigned long long tx_packets;
	int in_use;
	struct sockaddr_in6 ipv6_addr;
	struct in_addr ipv4_addr;
};

void *host_wan_stats(void *pData);
int host_wan_stats_thread();
void host_wan_stats_timer_callback(struct uloop_timeout *t);
void host_wan_stats_collect_timer(struct uloop_timeout *t);
void host_wan_stats_read_callback();
void host_wan_stats_fd_register(struct topologyd_private *priv);
void host_node_create_rd_wr_sockets();
void host_wan_topology_pm_update(int socket_fd, struct topologyd_private *priv);
#endif
